<!DOCTYPE html>
<html>

<head>

<meta charset="UTF-8">
<meta name=viewport content="width=device-width, initial-scale=1">


<title>SQL on MongoDB - Apache Drill</title>

<link href="//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css" rel="stylesheet" type="text/css"/>
<link href='//fonts.googleapis.com/css?family=PT+Sans' rel='stylesheet' type='text/css'/>
<link href="/css/site.css" rel="stylesheet" type="text/css"/>

<link rel="shortcut icon" href="/favicon.ico" type="image/x-icon"/>
<link rel="icon" href="/favicon.ico" type="image/x-icon"/>

<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js" language="javascript" type="text/javascript"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.3/jquery.easing.min.js" language="javascript" type="text/javascript"></script>
<script language="javascript" type="text/javascript" src="/js/modernizr.custom.js"></script>
<script language="javascript" type="text/javascript" src="/js/script.js"></script>
<script language="javascript" type="text/javascript" src="/js/drill.js"></script>

</head>


<body onResize="resized();">
  <div class="page-wrap">
    <div class="bui"></div>

<div id="menu" class="mw">
<ul>
  <li class='toc-categories'>
  <a class="expand-toc-icon" href="javascript:void(0);"><i class="fa fa-bars"></i></a>
  </li>
  <li class="logo"><a href="/"></a></li>
  <li class='expand-menu'>
  <a href="javascript:void(0);"><span class='menu-text'>Menu</span><span class='expand-icon'><i class="fa fa-bars"></i></span></a>
  </li>
  <li class='clear-float'></li>
  <li class="documentation-menu">
    <a href="/docs/">Documentation</a>
    <ul>
      
        <li><a href="/docs/getting-started/">Getting Started</a></li>
      
        <li><a href="/docs/architecture/">Architecture</a></li>
      
        <li><a href="/docs/tutorials/">Tutorials</a></li>
      
        <li><a href="/docs/install-drill/">Install Drill</a></li>
      
        <li><a href="/docs/configure-drill/">Configure Drill</a></li>
      
        <li><a href="/docs/connect-a-data-source/">Connect a Data Source</a></li>
      
        <li><a href="/docs/odbc-jdbc-interfaces/">ODBC/JDBC Interfaces</a></li>
      
        <li><a href="/docs/query-data/">Query Data</a></li>
      
        <li><a href="/docs/performance-tuning/">Performance Tuning</a></li>
      
        <li><a href="/docs/log-and-debug/">Log and Debug</a></li>
      
        <li><a href="/docs/sql-reference/">SQL Reference</a></li>
      
        <li><a href="/docs/data-sources-and-file-formats/">Data Sources and File Formats</a></li>
      
        <li><a href="/docs/develop-custom-functions/">Develop Custom Functions</a></li>
      
        <li><a href="/docs/troubleshooting/">Troubleshooting</a></li>
      
        <li><a href="/docs/developer-information/">Developer Information</a></li>
      
        <li><a href="/docs/release-notes/">Release Notes</a></li>
      
        <li><a href="/docs/sample-datasets/">Sample Datasets</a></li>
      
        <li><a href="/docs/archived-pages/">Archived Pages</a></li>
      
        <li><a href="/docs/progress-reports/">Progress Reports</a></li>
      
        <li><a href="/docs/project-bylaws/">Project Bylaws</a></li>
      
    </ul>
  </li>
  <li class='nav'>
    <a href="/community-resources/">Community</a>
    <ul>
      <li><a href="/team/">Team</a></li>
      <li><a href="/mailinglists/">Mailing Lists</a></li>
      <li><a href="/community-resources/">Community Resources</a></li>
    </ul>
  </li>
  <li class='nav'><a href="/faq/">FAQ</a></li>
  <li class='nav'><a href="/blog/">Blog</a></li>
  <li id="twitter-menu-item"><a href="https://twitter.com/apachedrill" title="apachedrill on twitter" target="_blank"><img src="/images/twitter_32_26_white.png" alt="twitter logo" align="center"></a> </li>
  <li class='search-bar'>
    <form id="drill-search-form">
      <input type="text" placeholder="Search Apache Drill" id="drill-search-term" />
      <button type="submit">
        <i class="fa fa-search"></i>
      </button>
    </form>
  </li>
  <li class="d">
    <a href="/download/">
      <i class="fa fa-cloud-download"></i> Download
    </a>
  </li>
</ul>
</div>

    <link href="/css/content.css" rel="stylesheet" type="text/css">

<div class="post int_text">
  <header class="post-header">
    <div class="int_title">
      <h1 class="post-title">SQL on MongoDB</h1>
    </div>
    <p class="post-meta">
    
    <strong>Authors:</strong>
    <ul>
      
        
        <li>Anil Kumar Batchu (SSE, Intuit India (IDC))</li>
      
        
        <li>Kamesh Bhallamudi (SSE, Intuit India (IDC))</li>
      
    </ul>
    
<strong>Date:</strong> Nov 19, 2014
</p>
  </header>
  <div class="addthis_sharing_toolbox"></div>

  <article class="post-content">
    <p>One of the many interesting and unique features about Drill is its ability to support multiple query languages, data formats, and data sources, as well as cross-platform querying (such as joining HBase tables with your Mongo collections) using ANSI SQL.</p>

<p>As of now, Drill supports multiple storage plugins, including HDFS, HBase, Hive, and LocalFileSystem. Since Drill is optimized for nested data, we realized that a Mongo storage plugin would be a useful feature.</p>

<p>So, recently Kamesh and I (we have an avid interest in all things Mongo) contributed the MongoDB storage plugin feature to the Apache Drill project. As part of this blog post, we would like to provide instructions on how to use this plugin, which has been included in the <a href="http://incubator.apache.org/drill/download/">Drill 0.6 release</a>.</p>

<p>The instructions are divided into the following subtopics:</p>

<ul>
<li>Drill and Mongo setup (standalone/replicated/sharded)</li>
<li>Running queries</li>
<li>Securely accessing MongoDB</li>
<li>Optimizations</li>
</ul>

<h2 id="drill-and-mongodb-setup-(standalone/replicated/sharded)">Drill and MongoDB Setup (Standalone/Replicated/Sharded)</h2>

<h3 id="standalone">Standalone</h3>

<ul>
<li>Start <code>mongod</code> process (<a href="http://docs.mongodb.org/manual/installation/">Install MongoDB</a>)</li>
<li>Start Drill in embedded mode (<a href="https://cwiki.apache.org/confluence/display/DRILL/Installing+Drill+in+Embedded+Mode">Installing Drill in Embedded Mode</a> &amp; <a href="https://cwiki.apache.org/confluence/pages/viewpage.action?pageId=44994063">Starting/Stopping Drill</a>) </li>
<li>Access the Web UI through the local drillbit: <a href="http://localhost:8047/">http://localhost:8047/</a></li>
<li><p>Enable the Mongo storage plugin and update its configuration:</p>
<div class="highlight"><pre><code class="language-json" data-lang="json"><span class="p">{</span>
  <span class="nt">&quot;type&quot;</span><span class="p">:</span> <span class="s2">&quot;mongo&quot;</span><span class="p">,</span>
  <span class="nt">&quot;connection&quot;</span><span class="p">:</span> <span class="s2">&quot;mongodb://localhost:27017&quot;</span><span class="p">,</span>
  <span class="nt">&quot;enabled&quot;</span><span class="p">:</span> <span class="kc">true</span>
<span class="p">}</span>
</code></pre></div></li>
</ul>

<p>By default, <code>mongod</code> listens on port 27017.</p>

<p><img src="/static/sql-on-mongodb/standalone.png" alt="Drill on MongoDB in standalone mode"></p>

<h3 id="replica-set">Replica Set</h3>

<ul>
<li>Start <code>mongod</code> processes in replication mode</li>
<li>Start Drill in distributed mode (<a href="https://cwiki.apache.org/confluence/display/DRILL/Installing+Drill+in+Distributed+Mode">Installing Drill in Distributed Mode</a> &amp; <a href="https://cwiki.apache.org/confluence/pages/viewpage.action?pageId=44994063">Starting/Stopping Drill</a>)</li>
<li>Access the Web UI through any drillbit: <a href="http://drillbit2:8047">http://drillbit2:8047</a></li>
<li><p>Enable the Mongo storage plugin and update its configuration:</p>
<div class="highlight"><pre><code class="language-json" data-lang="json"><span class="p">{</span>
  <span class="nt">&quot;type&quot;</span><span class="p">:</span> <span class="s2">&quot;mongo&quot;</span><span class="p">,</span>
  <span class="nt">&quot;connection&quot;</span><span class="p">:</span> <span class="s2">&quot;mongodb://&lt;host1&gt;:&lt;port1&gt;,&lt;host2&gt;:&lt;port2&gt;&quot;</span><span class="p">,</span>
  <span class="nt">&quot;enabled&quot;</span><span class="p">:</span> <span class="kc">true</span>
<span class="p">}</span>
</code></pre></div>
<p>Where <code>host1</code> and <code>host2</code> are <code>mongod</code> hostnames in the replica set.</p></li>
</ul>

<p><img src="/static/sql-on-mongodb/replicated.png" alt="Drill on MongoDB in replicated mode"></p>

<p>In replicated mode, whichever drillbit receives the query connects to the nearest <code>mongod</code> (local <code>mongod</code>) to read the data.</p>

<h3 id="sharded/sharded-with-replica-set">Sharded/Sharded with Replica Set</h3>

<ul>
<li>Start Mongo processes in sharded mode</li>
<li>Start Drill in distributed mode (<a href="https://cwiki.apache.org/confluence/display/DRILL/Installing+Drill+in+Distributed+Mode">Installing Drill in Distributed Mode</a> &amp; <a href="https://cwiki.apache.org/confluence/pages/viewpage.action?pageId=44994063">Starting/Stopping Drill</a>)</li>
<li>Access the Web UI through any drillbit: <a href="http://drillbit3:8047">http://drillbit3:8047</a></li>
<li><p>Enable the Mongo storage plugin and update its configuration:</p>
<div class="highlight"><pre><code class="language-json" data-lang="json"><span class="p">{</span> 
  <span class="nt">&quot;type&quot;</span><span class="p">:</span> <span class="s2">&quot;mongo&quot;</span><span class="p">,</span>
  <span class="nt">&quot;connection&quot;</span><span class="p">:</span> <span class="s2">&quot;mongodb://&lt;host1&gt;:&lt;port1&gt;,&lt;host2&gt;:&lt;port2&gt;&quot;</span><span class="p">,</span>
  <span class="nt">&quot;enabled&quot;</span><span class="p">:</span> <span class="kc">true</span>
<span class="p">}</span>
</code></pre></div>
<p>Where <code>host1</code> and <code>host2</code> are the <code>mongos</code> hostnames.</p></li>
</ul>

<p><img src="/static/sql-on-mongodb/sharded.png" alt="Drill on MongoDB in sharded mode"></p>

<p>In sharded mode, drillbit first connects to the <code>mongos</code> server to get the shard information.</p>

<h2 id="endpoint-assignments">Endpoint Assignments</h2>

<p>Drill is designed to maximize data locality:</p>

<ul>
<li>When drillbits and shards run together on the same machines, each drillbit (endpoint) will read the chunks from the local shard. That is, all the chunks from a shard will be assigned to its local drillbit. This is known as data locality, and is the ideal scenario.</li>
<li>When all drillbits and shards are running on different machines, chunks will be assigned to drillbits in a round-robin fashion. In this case there is no data locality.</li>
<li>When some of drillbits and shards are colocated, and some of them are running on different machines, partial data locality is achieved.</li>
</ul>

<h2 id="running-queries">Running Queries</h2>

<p>Here is a simple exercise that provides steps for creating an <code>empinfo</code> collection in an <code>employee</code> database in Mongo that you can query using Drill:</p>

<ol>
<li>Download <a href="http://media.mongodb.org/zips.json">zips.json</a> and the <a href="/static/sql-on-mongodb/empinfo.json">empinfo.json</a> dataset referenced at the end of blog.</li>
<li><p>Import the zips.json and empinfo.json files into Mongo using the following command:  </p>
<div class="highlight"><pre><code class="language-bash" data-lang="bash">mongoimport --host localhost --db <span class="nb">test</span> --collection zips &lt; zips.json
mongoimport --host localhost --db employee --collection empinfo &lt; empinfo.json
</code></pre></div></li>
<li><p>Issue the following queries either from sqlline (Drill’s shell) or from the Drill Web UI to get corresponding results from the Mongo collection. </p>

<ul>
<li>To issue queries from the web UI, open the Drill web UI and go to Query tab. </li>
<li><p>To issue queries from sqlline, connect to sqlline using the following command: </p>
<div class="highlight"><pre><code class="language-bash" data-lang="bash">&lt;DRILLHOME&gt;/bin/sqlline -u jdbc:drill:zk<span class="o">=</span>zkhost:2181 -n admin -p admin
</code></pre></div></li>
</ul></li>
<li><p>Queries:</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="k">SELECT</span> <span class="n">first_name</span><span class="p">,</span> <span class="n">last_name</span><span class="p">,</span> <span class="n">position_id</span>
<span class="k">FROM</span> <span class="n">mongo</span><span class="p">.</span><span class="n">employee</span><span class="p">.</span><span class="o">`</span><span class="n">empinfo</span><span class="o">`</span>
<span class="k">WHERE</span> <span class="n">employee_id</span> <span class="o">=</span> <span class="mi">1107</span> <span class="k">AND</span> <span class="n">position_id</span> <span class="o">=</span> <span class="mi">17</span> <span class="k">AND</span> <span class="n">last_name</span> <span class="o">=</span> <span class="s1">&#39;Yonce&#39;</span><span class="p">;</span>  

<span class="k">SELECT</span> <span class="n">city</span><span class="p">,</span> <span class="k">sum</span><span class="p">(</span><span class="n">pop</span><span class="p">)</span>
<span class="k">FROM</span> <span class="n">mongo</span><span class="p">.</span><span class="n">test</span><span class="p">.</span><span class="o">`</span><span class="n">zips</span><span class="o">`</span> <span class="n">zipcodes</span>
<span class="k">WHERE</span> <span class="k">state</span> <span class="k">IS</span> <span class="k">NOT</span> <span class="k">NULL</span> <span class="k">GROUP</span> <span class="k">BY</span> <span class="n">city</span>
<span class="k">ORDER</span> <span class="k">BY</span> <span class="k">sum</span><span class="p">(</span><span class="n">pop</span><span class="p">)</span> <span class="k">DESC</span> <span class="k">LIMIT</span> <span class="mi">1</span><span class="p">;</span>
</code></pre></div></li>
</ol>

<p><em>Note</em>: If a field contains a mixture of different data types across different records, such as both int and decimal values, then queries fail unless <code>store.mongo.all_text_mode = true</code> and aggregations fail in that case. For more information refer to <a href="https://issues.apache.org/jira/browse/DRILL-1475">DRILL-1475</a> and <a href="https://issues.apache.org/jira/browse/DRILL-1460">DRILL-1460</a>.</p>

<p>To set <code>store.mongo.all_text_mode = true</code>, execute the following command in sqlline:</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="k">alter</span> <span class="k">session</span> <span class="k">set</span> <span class="n">store</span><span class="p">.</span><span class="n">mongo</span><span class="p">.</span><span class="n">all_text_mode</span> <span class="o">=</span> <span class="k">true</span>
</code></pre></div>
<h2 id="securely-accessing-mongodb">Securely Accessing MongoDB</h2>

<p>Create two databases, emp and zips. For each database, create a user with read privileges. As an example, for the zips database, create a user “apache” with read privileges. For the emp database, create a user “drill” with read privileges.</p>

<p>The apache user will be able to query the zips database by using the following storage plugin configuration:</p>
<div class="highlight"><pre><code class="language-json" data-lang="json"><span class="p">{</span> 
  <span class="nt">&quot;type&quot;</span><span class="p">:</span> <span class="s2">&quot;mongo&quot;</span><span class="p">,</span>
  <span class="nt">&quot;connection&quot;</span><span class="p">:</span> <span class="s2">&quot;mongodb://apache:apache@localhost:27017/zips&quot;</span><span class="p">,</span>
  <span class="nt">&quot;enabled&quot;</span><span class="p">:</span> <span class="kc">true</span>
<span class="p">}</span>
</code></pre></div>
<p>The <code>drill</code> user will be able to query the <code>emp</code> database by using the following storage plugin configuration:</p>
<div class="highlight"><pre><code class="language-json" data-lang="json"><span class="p">{</span> 
  <span class="nt">&quot;type&quot;</span><span class="p">:</span> <span class="s2">&quot;mongo&quot;</span><span class="p">,</span>
  <span class="nt">&quot;connection&quot;</span><span class="p">:</span> <span class="s2">&quot;mongodb://drill:drill@localhost:27017/emp&quot;</span><span class="p">,</span>
  <span class="nt">&quot;enabled&quot;</span><span class="p">:</span> <span class="kc">true</span> 
<span class="p">}</span>
</code></pre></div>
<p><em>Note</em>: The security patch may be included in next release. Check <a href="https://issues.apache.org/jira/browse/DRILL-1502">DRILL-1502</a> for status.</p>

<h2 id="optimizations">Optimizations</h2>

<p>The MongoDB storage plugin supports predicate pushdown and projection pushdown. As of now, predicate pushdown is implemented for the following filters: <code>&gt;</code>, <code>&gt;=</code>, <code>&lt;</code>, <code>&lt;=</code>, <code>==</code>, <code>!=</code>, <code>isNull</code> and <code>isNotNull</code>.</p>

<p>We are excited about the release of the MongoDB storage plugin, and we believe that Drill is the perfect SQL query tool for MongoDB.</p>

  </article>
 <div id="disqus_thread"></div>
    <script type="text/javascript">
        /* * * CONFIGURATION VARIABLES: EDIT BEFORE PASTING INTO YOUR WEBPAGE * * */
        var disqus_shortname = 'drill'; // required: replace example with your forum shortname

        /* * * DON'T EDIT BELOW THIS LINE * * */
        (function() {
            var dsq = document.createElement('script'); dsq.type = 'text/javascript'; dsq.async = true;
            dsq.src = '//' + disqus_shortname + '.disqus.com/embed.js';
            (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(dsq);
        })();
    </script>
    <noscript>Please enable JavaScript to view the <a href="http://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
    
</div>
<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=ra-548b2caa33765e8d" async="async"></script>

  </div>
  <p class="push"></p>
<div id="footer" class="mw">
<div class="wrapper">
Copyright © 2012-2014 The Apache Software Foundation, licensed under the Apache License, Version 2.0.<br>
Apache and the Apache feather logo are trademarks of The Apache Software Foundation. Other names appearing on the site may be trademarks of their respective owners.<br/><br/>
</div>
</div>

  <script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
})(window,document,'script','//www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-53379651-1', 'auto');
ga('send', 'pageview');
</script>

</body>
</html>
